Index: /code/trunk/src/libraries/core/Core.cc
===================================================================
--- /code/trunk/src/libraries/core/Core.cc	(revision 8365)
+++ /code/trunk/src/libraries/core/Core.cc	(revision 8366)
@@ -98,4 +98,5 @@
         , lastLevelTimestamp_(0)
         , ogreConfigTimestamp_(0)
+        , bDevMode_(false)
     {
         // Set the hard coded fixed paths
@@ -212,10 +213,6 @@
 #ifdef ORXONOX_RELEASE
         const unsigned int defaultLevelLogFile = 3;
-        SetConfigValue(bDevMode_, false)
-            .description("Developer mode. If not set, hides some things from the user to not confuse him.");
 #else
         const unsigned int defaultLevelLogFile = 4;
-        SetConfigValue(bDevMode_, true)
-            .description("Developer mode. If not set, hides some things from the user to not confuse him.");
 #endif
         SetConfigValueExternal(softDebugLevelLogFile_, "OutputHandler", "softDebugLevelLogFile", defaultLevelLogFile)
@@ -223,4 +220,6 @@
         OutputHandler::getInstance().setSoftDebugLevel(OutputHandler::logFileOutputListenerName_s, this->softDebugLevelLogFile_);
 
+        SetConfigValue(bDevMode_, PathConfig::buildDirectoryRun())
+            .description("Developer mode. If not set, hides some things from the user to not confuse him.");
         SetConfigValue(language_, Language::getInstance().defaultLanguage_)
             .description("The language of the in game text")
Index: /code/trunk/src/libraries/core/Core.h
===================================================================
--- /code/trunk/src/libraries/core/Core.h	(revision 8365)
+++ /code/trunk/src/libraries/core/Core.h	(revision 8366)
@@ -91,4 +91,5 @@
                 { return this->ogreConfigTimestamp_; }
 
+            //! Developers bit. If returns false, some options are not available as to not confuse the normal user.
             inline bool inDevMode(void) const
                 { return this->bDevMode_; }
Index: /code/trunk/src/libraries/core/GraphicsManager.cc
===================================================================
--- /code/trunk/src/libraries/core/GraphicsManager.cc	(revision 8365)
+++ /code/trunk/src/libraries/core/GraphicsManager.cc	(revision 8366)
@@ -119,6 +119,6 @@
         Loader::open(resources_.get());
 
-        // Only for development runs
-        if (PathConfig::isDevelopmentRun())
+        // Only for runs in the build directory (not installed)
+        if (PathConfig::buildDirectoryRun())
             Ogre::ResourceGroupManager::getSingleton().addResourceLocation(PathConfig::getExternalDataPathString(), "FileSystem");
 
@@ -251,5 +251,5 @@
         std::string pluginPath = specialConfig::ogrePluginsDirectory;
 #ifdef DEPENDENCY_PACKAGE_ENABLE
-        if (!PathConfig::isDevelopmentRun())
+        if (!PathConfig::buildDirectoryRun())
         {
 #  if defined(ORXONOX_PLATFORM_WINDOWS)
Index: /code/trunk/src/libraries/core/PathConfig.cc
===================================================================
--- /code/trunk/src/libraries/core/PathConfig.cc	(revision 8365)
+++ /code/trunk/src/libraries/core/PathConfig.cc	(revision 8366)
@@ -84,5 +84,5 @@
         , configPath_(*(new bf::path()))
         , logPath_(*(new bf::path()))
-        , bDevRun_(false)
+        , bBuildDirectoryRun_(false)
     {
         //////////////////////////
@@ -138,5 +138,5 @@
         {
             COUT(1) << "Running from the build tree." << std::endl;
-            PathConfig::bDevRun_ = true;
+            PathConfig::bBuildDirectoryRun_ = true;
             modulePath_ = specialConfig::moduleDevDirectory;
         }
@@ -180,5 +180,5 @@
     void PathConfig::setConfigurablePaths()
     {
-        if (bDevRun_)
+        if (bBuildDirectoryRun_)
         {
             dataPath_         = specialConfig::dataDevDirectory;
Index: /code/trunk/src/libraries/core/PathConfig.h
===================================================================
--- /code/trunk/src/libraries/core/PathConfig.h	(revision 8365)
+++ /code/trunk/src/libraries/core/PathConfig.h	(revision 8366)
@@ -114,5 +114,5 @@
 
             //! Return true for runs in the build directory (not installed)
-            static bool isDevelopmentRun() { return getInstance().bDevRun_; }
+            static bool buildDirectoryRun() { return getInstance().bBuildDirectoryRun_; }
 
         private:
@@ -129,5 +129,5 @@
             std::vector<std::string> getModulePaths();
 
-            //! Path to the parent directory of the ones above if program was installed with relativ paths
+            //! Path to the parent directory of the ones above if program was installed with relative paths
             boost::filesystem::path& rootPath_;
             boost::filesystem::path& executablePath_;        //!< Path to the executable
@@ -138,5 +138,5 @@
             boost::filesystem::path& logPath_;               //!< Path to the log files folder
 
-            bool                     bDevRun_;               //!< True for runs in the build directory (not installed)
+            bool                     bBuildDirectoryRun_;    //!< True for runs in the build directory (not installed)
             static PathConfig* singletonPtr_s;
     }; //tolua_export
Index: /code/trunk/src/libraries/core/command/TclBind.cc
===================================================================
--- /code/trunk/src/libraries/core/command/TclBind.cc	(revision 8365)
+++ /code/trunk/src/libraries/core/command/TclBind.cc	(revision 8366)
@@ -140,8 +140,8 @@
     {
 #ifdef DEPENDENCY_PACKAGE_ENABLE
-        if (PathConfig::isDevelopmentRun())
+        if (PathConfig::buildDirectoryRun())
             return (std::string(specialConfig::dependencyLibraryDirectory) + "/tcl");
         else
-            return (PathConfig::getRootPathString() + "lib/tcl");
+            return (PathConfig::getRootPathString() + specialConfig::defaultLibraryPath + "/tcl");
 #else
         return "";
Index: /code/trunk/src/libraries/core/input/KeyBinder.cc
===================================================================
--- /code/trunk/src/libraries/core/input/KeyBinder.cc	(revision 8365)
+++ /code/trunk/src/libraries/core/input/KeyBinder.cc	(revision 8366)
@@ -253,8 +253,8 @@
         COUT(3) << "KeyBinder: Loading key bindings..." << std::endl;
 
-        this->configFile_ = new ConfigFile(this->filename_, !PathConfig::isDevelopmentRun());
+        this->configFile_ = new ConfigFile(this->filename_, !PathConfig::buildDirectoryRun());
         this->configFile_->load();
 
-        if (PathConfig::isDevelopmentRun())
+        if (PathConfig::buildDirectoryRun())
         {
             // Dev users should have combined key bindings files
@@ -287,5 +287,5 @@
             addButtonToCommand(binding, it->second);
             std::string str = binding;
-            if (PathConfig::isDevelopmentRun() && binding.empty())
+            if (PathConfig::buildDirectoryRun() && binding.empty())
                 str = "NoBinding";
             it->second->setBinding(this->configFile_, this->fallbackConfigFile_, binding, bTemporary);
Index: /code/trunk/src/libraries/tools/ResourceLocation.cc
===================================================================
--- /code/trunk/src/libraries/tools/ResourceLocation.cc	(revision 8365)
+++ /code/trunk/src/libraries/tools/ResourceLocation.cc	(revision 8366)
@@ -76,5 +76,5 @@
         if (bf::exists(PathConfig::getDataPath() / this->getPath()))
             path = PathConfig::getDataPath() / this->getPath();
-        else if (PathConfig::isDevelopmentRun() && bf::exists(PathConfig::getExternalDataPath() / this->getPath()))
+        else if (PathConfig::buildDirectoryRun() && bf::exists(PathConfig::getExternalDataPath() / this->getPath()))
             path = PathConfig::getExternalDataPath() / this->getPath();
         else